您的位置:首页 > 编程语言 > Go语言

CodeForces 598D Igor In the Museum【dfs】

2016-03-06 21:48 363 查看
D. Igor In the Museum


Time Limit:1000MS     Memory Limit:262144KB     64bit IO Format:%I64d & %I64u
Submit Status Practice CodeForces
598D

Description

Igor is in the museum and he wants to see as many pictures as possible.

Museum can be represented as a rectangular field of n × m cells. Each cell is either empty or impassable. Empty cells are marked with '.', impassable
cells are marked with '*'. Every two adjacent cells of different types (one empty and one impassable) are divided by a wall containing one picture.

At the beginning Igor is in some empty cell. At every moment he can move to any empty cell that share a side with the current one.

For several starting positions you should calculate the maximum number of pictures that Igor can see. Igor is able to see the picture only if he is in the cell adjacent to the wall with this picture. Igor have a lot of time, so he will examine every picture
he can see.

Input

First line of the input contains three integers n, m and k (3 ≤ n, m ≤ 1000, 1 ≤ k ≤ min(n·m, 100 000)) —
the museum dimensions and the number of starting positions to process.

Each of the next n lines contains m symbols '.', '*'
— the description of the museum. It is guaranteed that all border cells are impassable, so Igor can't go out from the museum.

Each of the last k lines contains two integers x and y (1 ≤ x ≤ n, 1 ≤ y ≤ m) —
the row and the column of one of Igor's starting positions respectively. Rows are numbered from top to bottom, columns — from left to right. It is guaranteed that all starting positions are empty cells.

Output

Print k integers — the maximum number of pictures, that Igor can see if he starts in corresponding position.

Sample Input

Input
5 6 3
******
*..*.*
******
*....*
******
2 2
2 5
4 3


Output
6
4
10


Input
4 4 1
****
*..*
*.**
****
3 2


Output
8


题意:

给出n*m 的地图,其中有空地 ‘.’,其中* 代表的是墙上挂的画,上下左右相邻的空地可以相互到达或者看到画,现在给出一个坐标代表当前位置,问最多能看到多少副画。

题解:

如果直接用搜索的话,因为多组的询问,导致做了重复的操作,因此需要预处理一下,首先把连通的方格编上相同的编号,然后进行搜索时,累加编号对应的数值,最后询问的时候,直接根据编号的对应就可以了。

常规方法空间浪费的有点多,可以使用map 进行空间优化。

#include<stdio.h>
#include<string.h>
const int maxn=1005;
char map[maxn][maxn];
int dx[]={0,0,1,-1},dy[]={1,-1,0,0},ans[maxn*maxn],vis[maxn][maxn];
void dfs(int x,int y,int num)
{
for(int i=0;i<4;++i)
{
int tx=x+dx[i],ty=y+dy[i];
if(map[tx][ty]=='*')//统计
{
++ans[num];
continue;
}
if(!vis[tx][ty])
{
vis[tx][ty]=num;//编上相同的编号
dfs(tx,ty,num);
}
}
}
int main()
{
int n,m,k;
while(~scanf("%d%d%d",&n,&m,&k))
{
for(int i=0;i<n;++i)
{
scanf("%s",map[i]);
}
int cnt=0;
memset(ans,0,sizeof(ans));
for(int i=1;i<n;++i)//打表预处理
{
for(int j=1;j<m;++j)
{
if(!vis[i][j]&&map[i][j]=='.')
{
vis[i][j]=++cnt;//编号,
dfs(i,j,cnt);//连通的全部编上相同的号
}
}
}
while(k--)
{
int bx,by;
scanf("%d%d",&bx,&by);
printf("%d\n",ans[vis[bx-1][by-1]]);//查表
}
}
return 0;
}


ps:这道题错了很多遍,不但有不细心,还有搜索掌握的不够好,继续加油吧!
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: